import types

class Table(object):
    __tadah__ = None
    __table__ = None

    def __init__(self,tadah=None,**kwargs):
        if tadah is not None: self.__tadah__ = tadah
        for key,value in kwargs.items():
            if hasattr(self,key): setattr(self,key,value)
        for attrName in filter(lambda x: not x.startswith('_'),dir(self)):
            attr = getattr(self,attrName)
            if not callable(attr): attr.table = self

    def __str__(self):
        return self.__table__

    def __repr__(self):
        result = 'CREATE TABLE '+self.__table__+' (\n'
        for attrName in filter(lambda x: not x.startswith('_'),dir(self)):
            attr = getattr(self,attrName)
            if not callable(attr): result += str(attr) + ' ' + repr(attr) + ',\n'
        if result[-2:]==',\n': result=result[:-2]
        result += ');'
        return result;

    @classmethod
    #def select(cls,tadah,*args,**kwargs):
    def select(cls,*args,**kwargs):
        print "SELECT * FROM %s WHERE %s"%(cls.__table__," AND ".join(args))
        return
        def result(cursor):
            pass
        # TODO kwargs['columns']
        if len(args)==0:
            request = self.__tadah__.execute("SELECT * FROM %s",cls.__table__)
        else:
            request = self.__tadah__.execute("SELECT * FROM %s WHERE %s",cls.__table__," AND ".join(args))
        return request    

    def create(self):
        return self.__tadah__.execute(repr(self))

class Col(object):
    __name__  = None
    default = None
    value = None
    length = None
    null = False
    table = None

    def __init__(self,name,**kwargs):
        self.name = name
        for key,value in kwargs.items():
            if hasattr(self,key): setattr(self,key,value)

    def _get_name(self):
        return self.__name__
    def _set_name(self,value):
        assert self.__name__ is None, "Cannot change column name. Requested from %s to %s."%(self.__name__,value)
        self.__name__ = value
    name = property(_get_name,_set_name)

    def _get_type(self):
        return types.NoneType
    type = property(_get_type)

    def _get_dbtype(self):
        return 'None'
    dbtype = property(_get_dbtype)

    def __str__(self):
        if self.table is not None: return str(self.table) + "." + self.name
        return self.name

    def __repr__(self):
        result = self.dbtype
        if not self.null: result += ' NOT NULL'
        if self.default is not None: result += " DEFAULT '%s'"%self.default
        return result

    def __lt__(self,other):
        return '( '+str(self) + ' < ' + str(other) + ' )'
    def __le__(self,other):
        return '( '+str(self) + ' <= ' + str(other) + ' )'
    def __eq__(self,other):
        return '( '+str(self) + ' = ' + str(other) + ' )'
    def __ne__(self,other):
        return '( NOT ' + str(self) + ' = ' + str(other) + ' )'
    def __gt__(self,other):
        return '( '+str(self) + ' > ' + str(other) + ' )'
    def __ge__(self,other):
        return '( '+str(self) + ' >= ' + str(other) + ' )'

class StringCol(Col):
    def _get_type(self):
        return types.StringType
    type = property(_get_type)

    def _get_dbtype(self):
        if self.length is not None: return 'varchar(%d)'%self.length
        return 'varchar'
    dbtype = property(_get_dbtype)

